
;CodeVisionAVR C Compiler V1.24.8d Professional
;(C) Copyright 1998-2006 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega48
;Clock frequency        : 7,372800 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 128 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: No
;Enhanced core instructions    : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega48
	#pragma AVRPART MEMORY PROG_FLASH 4096
	#pragma AVRPART MEMORY EEPROM 256
	#pragma AVRPART MEMORY INT_SRAM SIZE 512
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x100

	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU EECR=0x1F
	.EQU EEDR=0x20
	.EQU EEARL=0x21
	.EQU EEARH=0x22
	.EQU SPSR=0x2D
	.EQU SPDR=0x2E
	.EQU SMCR=0x33
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU WDTCSR=0x60
	.EQU UCSR0A=0xC0
	.EQU UDR0=0xC6
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU GPIOR0=0x1E
	.EQU GPIOR1=0x2A
	.EQU GPIOR2=0x2B

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x01
	.EQU __sm_mask=0x0E
	.EQU __sm_adc_noise_red=0x02
	.EQU __sm_powerdown=0x04
	.EQU __sm_powersave=0x06
	.EQU __sm_standby=0x0C

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "1.vec"
	.INCLUDE "1.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	WDR
	IN   R26,MCUSR
	CBR  R26,8
	OUT  MCUSR,R26
	STS  WDTCSR,R31
	STS  WDTCSR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x200)
	LDI  R25,HIGH(0x200)
	LDI  R26,LOW(0x100)
	LDI  R27,HIGH(0x100)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;GPIOR0-GPIOR2 INITIALIZATION
	LDI  R30,__GPIOR0_INIT
	OUT  GPIOR0,R30
	LDI  R30,__GPIOR1_INIT
	OUT  GPIOR1,R30
	LDI  R30,__GPIOR2_INIT
	OUT  GPIOR2,R30

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x2FF)
	OUT  SPL,R30
	LDI  R30,HIGH(0x2FF)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x180)
	LDI  R29,HIGH(0x180)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x180
;       1 #include <mega48.h>
;       2 #include <stdio.h> 
;       3 #include <stdlib.h>
;       4 #include <STRING.H> 
;       5 #include <ctype.H>
;       6 #include <i2c.h> 
;       7 #include <delay.h>
;       8 #include <math.h>    
;       9 
;      10 #include <functions.c>
;      11 // Yak module
;      12 #define TWINT       0b10000000
;      13 #define TWEA        0b01000000
;      14 #define TWSTA       0b00100000
;      15 #define TWSTO       0b00010000
;      16 #define TWWC        0b00001000
;      17 #define TWEN        0b00000100
;      18 #define TWIE        0b00000001
;      19 
;      20 #define SLA_W       0b10100000
;      21 #define SLA_R       0b10100001
;      22 
;      23 #define EEPROM_BUS_ADDRESS 0xa0
;      24 
;      25 unsigned char ext_eeprom_read(unsigned int address) 
;      26 {

	.CSEG
_ext_eeprom_read:
;      27         unsigned char data, addrh, addrl;
;      28         addrh=(((address<<4)>>12)<<1);
	RCALL __SAVELOCR3
;	address -> Y+3
;	data -> R16
;	addrh -> R17
;	addrl -> R18
	LDD  R30,Y+3
	LDD  R31,Y+3+1
	RCALL __LSLW4
	RCALL __LSRW4
	MOV  R30,R31
	LDI  R31,0
	LSL  R30
	ROL  R31
	MOV  R17,R30
;      29         addrl=(char)address;
	LDD  R18,Y+3
;      30         i2c_start();
	RCALL _i2c_start
;      31         i2c_write(EEPROM_BUS_ADDRESS | addrh);
	MOV  R30,R17
	ORI  R30,LOW(0xA0)
	RCALL SUBOPT_0x0
;      32         i2c_write(addrl);
	ST   -Y,R18
	RCALL _i2c_write
;      33         i2c_start();
	RCALL _i2c_start
;      34         i2c_write(EEPROM_BUS_ADDRESS | 1 | addrh);
	MOV  R30,R17
	ORI  R30,LOW(0xA1)
	RCALL SUBOPT_0x0
;      35         data=i2c_read(1);
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _i2c_read
	MOV  R16,R30
;      36         i2c_stop();
	RCALL _i2c_stop
;      37         return data;
	MOV  R30,R16
	RCALL __LOADLOCR3
	ADIW R28,5
	RET
;      38 }
;      39 
;      40 void ext_eeprom_write(unsigned char address, unsigned char data) 
;      41 {
_ext_eeprom_write:
;      42         i2c_start();
;	address -> Y+1
;	data -> Y+0
	RCALL _i2c_start
;      43         i2c_write(EEPROM_BUS_ADDRESS);
	LDI  R30,LOW(160)
	RCALL SUBOPT_0x0
;      44         i2c_write(address);
	LDD  R30,Y+1
	RCALL SUBOPT_0x0
;      45         i2c_write(data);
	LD   R30,Y
	RCALL SUBOPT_0x0
;      46         i2c_stop();
	RCALL _i2c_stop
;      47         delay_ms(10);
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL SUBOPT_0x1
	RCALL _delay_ms
;      48 }
	ADIW R28,2
	RET
;      49 
;      50 // ================= Write byte to internal EEPROM ===========
;      51 void eeprom_write(unsigned int uiAddress, unsigned char ucData)
;      52 {
_eeprom_write:
;      53         #asm("cli")
;	uiAddress -> Y+1
;	ucData -> Y+0
	cli
;      54         while(EECR.1);
_0x3:
	SBIC 0x1F,1
	RJMP _0x3
;      55         EEAR=uiAddress;
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	OUT  0x21+1,R31
	OUT  0x21,R30
;      56         EEDR=ucData;
	LD   R30,Y
	OUT  0x20,R30
;      57         EECR.2=1;
	SBI  0x1F,2
;      58         EECR.1=1;
	SBI  0x1F,1
;      59         #asm("sei")
	sei
;      60 } 
	ADIW R28,3
	RET
;      61 
;      62 // ================= Read byte from internal EEPROM =========
;      63 unsigned int eeprom_read(unsigned int uiAddress)
;      64 {       
_eeprom_read:
;      65         #asm("cli")
;	uiAddress -> Y+0
	cli
;      66         while(EECR.1);
_0x6:
	SBIC 0x1F,1
	RJMP _0x6
;      67         EEAR=uiAddress;
	LD   R30,Y
	LDD  R31,Y+1
	OUT  0x21+1,R31
	OUT  0x21,R30
;      68         EECR.0=1;
	SBI  0x1F,0
;      69         return EEDR;
	IN   R30,0x20
	RCALL SUBOPT_0x2
	ADIW R28,2
	RET
;      70         #asm("sei")
	sei
;      71 } 
	ADIW R28,2
	RET
;      72 
;      73 // ================= HEX to DEC conversion ===================
;      74 unsigned int hexdec(char* str)
;      75 {       
_hexdec:
;      76         signed long i,j,a,b,c;
;      77         unsigned int ln=0, tmpint=0;
;      78         ln=strlen(str)-1;
	SBIW R28,20
	RCALL __SAVELOCR4
;	*str -> Y+24
;	i -> Y+20
;	j -> Y+16
;	a -> Y+12
;	b -> Y+8
;	c -> Y+4
;	ln -> R16,R17
;	tmpint -> R18,R19
	LDI  R16,0
	LDI  R17,0
	LDI  R18,0
	LDI  R19,0
	LDD  R30,Y+24
	LDD  R31,Y+24+1
	RCALL SUBOPT_0x1
	RCALL _strlen
	SBIW R30,1
	MOVW R16,R30
;      79         //printf(" \r\n\r\n unsigned int hexdec(char* str) \r\n - str = %s \r\n ",str);
;      80         //printf(" \r\n - ln = %X \r\n ",ln);
;      81         
;      82         i=ln; j=0;
	MOVW R30,R16
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x4
	__CLRD1S 16
;      83         while (i>=0)
_0x9:
	RCALL SUBOPT_0x5
	RCALL __CPD20
	BRGE PC+2
	RJMP _0xB
;      84         { 
;      85                 if (i==0) a=1;
	RCALL SUBOPT_0x6
	RCALL __CPD10
	BRNE _0xC
	__GETD1N 0x1
	RCALL SUBOPT_0x7
;      86                 if (i==1) a=0x0F;
_0xC:
	RCALL SUBOPT_0x5
	__CPD2N 0x1
	BRNE _0xD
	__GETD1N 0xF
	RCALL SUBOPT_0x7
;      87                 if (i==2) a=0xFF;
_0xD:
	RCALL SUBOPT_0x5
	__CPD2N 0x2
	BRNE _0xE
	__GETD1N 0xFF
	RCALL SUBOPT_0x7
;      88                 if (i==3) a=0xFFF;
_0xE:
	RCALL SUBOPT_0x5
	__CPD2N 0x3
	BRNE _0xF
	__GETD1N 0xFFF
	RCALL SUBOPT_0x7
;      89                 if (i==4) a=0xFFFF; 
_0xF:
	RCALL SUBOPT_0x5
	__CPD2N 0x4
	BRNE _0x10
	__GETD1N 0xFFFF
	RCALL SUBOPT_0x7
;      90                 
;      91                 b=toint(str[j]); c=a*b;
_0x10:
	RCALL SUBOPT_0x8
	LDD  R26,Y+24
	LDD  R27,Y+24+1
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0xA
	RCALL _toint
	CLR  R31
	CLR  R22
	CLR  R23
	__PUTD1S 8
	__GETD2S 12
	RCALL __MULD12
	__PUTD1S 4
;      92                 tmpint=tmpint+c;
	MOVW R26,R18
	CLR  R24
	CLR  R25
	RCALL __ADDD12
	MOVW R18,R30
;      93                 printf(" \r\n a = %u ; b = %u ; c = %u ; \r\n ",a,b,c);
	__POINTW1FN _0,0
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0xB
	RCALL SUBOPT_0xB
	RCALL SUBOPT_0xB
	LDI  R24,12
	RCALL _printf
	ADIW R28,14
;      94                 i--; j++;
	RCALL SUBOPT_0x6
	SBIW R30,1
	SBCI R22,0
	SBCI R23,0
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x8
	__SUBD1N -1
	__PUTD1S 16
;      95         }
	RJMP _0x9
_0xB:
;      96         
;      97         printf(" \r\n - tmpint = %X \r\n ",tmpint);
	__POINTW1FN _0,35
	RCALL SUBOPT_0x1
	MOVW R30,R18
	RCALL SUBOPT_0xC
;      98         return tmpint;
	MOVW R30,R18
	RCALL __LOADLOCR4
	ADIW R28,26
	RET
;      99 }
;     100 
;     101 #asm
;     102    .equ __i2c_port=0x0B ;PORTD
   .equ __i2c_port=0x0B ;PORTD
;     103    .equ __sda_bit=5
   .equ __sda_bit=5
;     104    .equ __scl_bit=6
   .equ __scl_bit=6
;     105 #endasm
;     106  
;     107 #define RXB8 1
;     108 #define TXB8 0
;     109 #define UPE 2
;     110 #define OVR 3
;     111 #define FE 4
;     112 #define UDRE 5
;     113 #define RXC 7
;     114 
;     115 #define FRAMING_ERROR (1<<FE)
;     116 #define PARITY_ERROR (1<<UPE)
;     117 #define DATA_OVERRUN (1<<OVR)
;     118 #define DATA_REGISTER_EMPTY (1<<UDRE)
;     119 #define RX_COMPLETE (1<<RXC)
;     120 
;     121 // USART Receiver buffer
;     122 #define RX_BUFFER_SIZE0 32
;     123 char rx_buffer0[RX_BUFFER_SIZE0];

	.DSEG
_rx_buffer0:
	.BYTE 0x20
;     124 unsigned char rx_wr_index0,rx_counter0;//,rx_rd_index0;
;     125 bit rx_buffer_overflow0;
;     126 
;     127 //AT PROTOCOL
;     128 bit ATECHO=1;
;     129 #define MAX_INT_EEPROM 0xFF
;     130 #define MAX_EXT_EEPROM 0x3FFF
;     131 
;     132 flash char AT_C[]="AT";

	.CSEG
;     133 flash char AT_E0[]="ATE0";
;     134 flash char AT_E1[]="ATE1";
;     135 flash char AT_INFO[]="AT+INFO";
;     136 flash char AT_IEEPR[]="AT+IEEPR=";
;     137 flash char AT_IEEPW[]="AT+IEEPW=";
;     138 flash char AT_EEEPR[]="AT+EEEPR=";
;     139 flash char AT_EEEPW[]="AT+EEEPW=";
;     140 
;     141 #pragma warn-
;     142 
;     143 // USART Receiver interrupt service routine
;     144 interrupt [USART_RXC] void usart_rx_isr(void)
;     145 {
_usart_rx_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;     146 signed char scmptmp=-1;
;     147 char i=0, j=0;
;     148 char attmp[16];
;     149 unsigned int tmpint=0,EEP=0;
;     150 
;     151 //unsigned char data;
;     152 
;     153 char status,data;
;     154 status=UCSR0A;
	SBIW R28,19
	LDI  R24,2
	LDI  R26,LOW(1)
	LDI  R27,HIGH(1)
	LDI  R30,LOW(_0x11*2)
	LDI  R31,HIGH(_0x11*2)
	RCALL __INITLOCB
	RCALL __SAVELOCR6
;	scmptmp -> R16
;	i -> R17
;	j -> R18
;	attmp -> Y+9
;	tmpint -> R19,R20
;	EEP -> Y+7
;	status -> R21
;	data -> Y+6
	LDI  R16,255
	LDI  R17,0
	LDI  R18,0
	LDI  R19,0
	LDI  R20,0
	LDS  R21,192
;     155 data=UDR0;
	LDS  R30,198
	STD  Y+6,R30
;     156 if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0)
	MOV  R30,R21
	ANDI R30,LOW(0x1C)
	BREQ PC+2
	RJMP _0x12
;     157    {
;     158         rx_buffer0[rx_wr_index0]=data;
	MOV  R30,R2
	RCALL SUBOPT_0x2
	SUBI R30,LOW(-_rx_buffer0)
	SBCI R31,HIGH(-_rx_buffer0)
	LDD  R26,Y+6
	STD  Z+0,R26
;     159         if (++rx_wr_index0 == RX_BUFFER_SIZE0)
	INC  R2
	LDI  R30,LOW(32)
	CP   R30,R2
	BRNE _0x13
;     160         {
;     161                 rx_wr_index0=0;
	CLR  R2
;     162                 rx_counter0=0;
	RCALL SUBOPT_0xD
;     163                 rx_wr_index0=0;
;     164                 tmpint=0;
;     165                 for (i=0; i==RX_BUFFER_SIZE0; i++) rx_buffer0[i]=0;
_0x15:
	CPI  R17,32
	BRNE _0x16
	RCALL SUBOPT_0xE
;     166                 for (i=0; i==16; i++) attmp[i]=0;
	SUBI R17,-1
	RJMP _0x15
_0x16:
	LDI  R17,LOW(0)
_0x18:
	CPI  R17,16
	BRNE _0x19
	RCALL SUBOPT_0xF
;     167         };
	SUBI R17,-1
	RJMP _0x18
_0x19:
_0x13:
;     168         if (++rx_counter0 == RX_BUFFER_SIZE0)
	INC  R3
	LDI  R30,LOW(32)
	CP   R30,R3
	BRNE _0x1A
;     169         {
;     170                 rx_counter0=0;
	CLR  R3
;     171                 rx_buffer_overflow0=1;
	SBI  0x1E,0
;     172                 rx_counter0=0;
	RCALL SUBOPT_0xD
;     173                 rx_wr_index0=0;
;     174                 tmpint=0;
;     175                 for (i=0; i==RX_BUFFER_SIZE0; i++) rx_buffer0[i]=0;
_0x1C:
	CPI  R17,32
	BRNE _0x1D
	RCALL SUBOPT_0xE
;     176                 for (i=0; i==16; i++) attmp[i]=0;
	SUBI R17,-1
	RJMP _0x1C
_0x1D:
	LDI  R17,LOW(0)
_0x1F:
	CPI  R17,16
	BRNE _0x20
	RCALL SUBOPT_0xF
;     177         };
	SUBI R17,-1
	RJMP _0x1F
_0x20:
_0x1A:
;     178           
;     179         if (data==13)
	LDD  R26,Y+6
	CPI  R26,LOW(0xD)
	BREQ PC+2
	RJMP _0x21
;     180         {
;     181                 rx_buffer0[rx_wr_index0-1]=NULL;
	MOV  R30,R2
	SUBI R30,LOW(1)
	RCALL SUBOPT_0x2
	SUBI R30,LOW(-_rx_buffer0)
	SBCI R31,HIGH(-_rx_buffer0)
	MOVW R26,R30
	LDI  R30,LOW(0)
	ST   X,R30
;     182                 
;     183                 //==============AT COMMAND SECTOR BEGIN=================
;     184                 scmptmp=strcmpf(rx_buffer0,AT_C);
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0x1
	LDI  R30,LOW(_AT_C*2)
	LDI  R31,HIGH(_AT_C*2)
	RCALL SUBOPT_0x1
	RCALL _strcmpf
	RCALL SUBOPT_0x11
;     185                 if (scmptmp==0)
	BRNE _0x22
;     186                 {
;     187                         if (ATECHO==1) printf(" \r\n\r\n%s ",rx_buffer0);
	SBIC 0x1E,1
	RCALL SUBOPT_0x12
;     188                         printf(" \r\n\r\nOK\r\n ",rx_buffer0);
	__POINTW1FN _0,66
	RJMP _0xD9
;     189                         goto GT;    
;     190                 };
_0x22:
;     191  /*               
;     192                 //------AT command echo off-------------
;     193                 scmptmp=strcmpf(rx_buffer0,AT_E0);
;     194                 if (scmptmp==0)
;     195                 {
;     196                         if (ATECHO==1) printf(" \r\n\r\n%s ",rx_buffer0);
;     197                         printf(" \r\nCOMMAND ECHO OFF\r\n\r\nOK\r\n ");
;     198                         ATECHO=0;
;     199                         goto GT;    
;     200                 };
;     201                 
;     202                 //------AT command echo on--------------
;     203                 scmptmp=strcmpf(rx_buffer0,AT_E1);
;     204                 if (scmptmp==0)
;     205                 {
;     206                         if (ATECHO==1) printf(" \r\n\r\n%s ",rx_buffer0);
;     207                         printf(" \r\nCOMMAND ECHO ON\r\n\r\nOK\r\n ");
;     208                         ATECHO=1;
;     209                         goto GT;    
;     210                 };
;     211                                 
;     212                 //------Show info-----------------------
;     213                 scmptmp=strcmpf(rx_buffer0,AT_INFO);
;     214                 if (scmptmp==0)
;     215                 {
;     216                         if (ATECHO==1) printf(" \r\n\r\n%s ",rx_buffer0);
;     217                         printf("\r\n ATMEL ATMEGA48 \r\n Max.EEPROM address = 0x%X \r\n Autor: Yak\r\n Date: 07.10.2006\r\n\r\n OK\r\n ",MAX_INT_EEPROM);
;     218                         goto GT;    
;     219                 };
;     220  */               
;     221                 //-------Internal EEPROM read-----------
;     222                 scmptmp=strncmpf(rx_buffer0,AT_IEEPR,9);
	RCALL SUBOPT_0x13
	LDI  R30,LOW(_AT_IEEPR*2)
	LDI  R31,HIGH(_AT_IEEPR*2)
	RCALL SUBOPT_0x14
;     223                 if (scmptmp==0)
	BRNE _0x25
;     224                 {       
;     225                         while (rx_buffer0[i+9]!=NULL)
_0x26:
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x16
	CPI  R30,0
	BREQ _0x28
;     226                         {
;     227                                 attmp[i]=rx_buffer0[i+9];
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x18
;     228                                 if (!( (isdigit(attmp[i])) || (isxdigit(attmp[i])) )) goto FD;
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0x19
	BRNE _0x2A
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0x1A
	BREQ _0x2B
_0x2A:
	RJMP _0x29
_0x2B:
	RJMP _0x2C
;     229                                 i++;
_0x29:
	SUBI R17,-1
;     230                         };
	RJMP _0x26
_0x28:
;     231                         tmpint=hexdec(attmp);
	RCALL SUBOPT_0x1B
;     232                         
;     233                         if ((tmpint<0)||(tmpint>MAX_INT_EEPROM))
	BRLO _0x2E
	__CPWRN 19,20,256
	BRLO _0x2D
_0x2E:
;     234                         {
;     235 FD:
_0x2C:
;     236                                 if (ATECHO==1) printf("\r\n\r\n%s",rx_buffer0);
	SBIC 0x1E,1
	RCALL SUBOPT_0x1C
;     237                                 printf("\r\n\r\nVALUE ERROR\r\n");
	RCALL SUBOPT_0x1D
;     238                                 goto GT; 
	RJMP _0x24
;     239                         };
_0x2D:
;     240                         
;     241                         EEP=eeprom_read(tmpint);
	RCALL SUBOPT_0x1E
	RCALL _eeprom_read
	RCALL SUBOPT_0x1F
;     242                         if (ATECHO==1) printf(" \r\n\r\n%s ",rx_buffer0);
	SBIC 0x1E,1
	RCALL SUBOPT_0x12
;     243                         printf(" \r\n+IEEPR=0x%X\r\n\r\nOK\r\n ",EEP);
	__POINTW1FN _0,102
	RCALL SUBOPT_0x1
	LDD  R30,Y+9
	LDD  R31,Y+9+1
	RJMP _0xDA
;     244                         goto GT;    
;     245                 };
_0x25:
;     246                 
;     247                 //-------Internal EEPROM write----------
;     248                 scmptmp=strncmpf(rx_buffer0,AT_IEEPW,9);
	RCALL SUBOPT_0x13
	LDI  R30,LOW(_AT_IEEPW*2)
	LDI  R31,HIGH(_AT_IEEPW*2)
	RCALL SUBOPT_0x14
;     249                 if (scmptmp==0)
	BREQ PC+2
	RJMP _0x32
;     250                 { 
;     251                         while (rx_buffer0[i+9]!=',')
_0x33:
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x16
	CPI  R30,LOW(0x2C)
	BREQ _0x35
;     252                         {
;     253                                 attmp[i]=rx_buffer0[i+9];
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x18
;     254                                 if (!( (isdigit(attmp[i])) || (isxdigit(attmp[i])) )) goto GD;
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0x19
	BRNE _0x37
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0x1A
	BREQ _0x38
_0x37:
	RJMP _0x36
_0x38:
	RJMP _0x39
;     255                                 i++;
_0x36:
	SUBI R17,-1
;     256                         };
	RJMP _0x33
_0x35:
;     257                         tmpint=hexdec(attmp);
	RCALL SUBOPT_0x1B
;     258                         
;     259                         if ((tmpint<0)||(tmpint>MAX_INT_EEPROM))
	BRLO _0x3B
	__CPWRN 19,20,256
	BRLO _0x3A
_0x3B:
;     260                         {
;     261 GD:
_0x39:
;     262                                 if (ATECHO==1) printf("\r\n\r\n%s",rx_buffer0);
	SBIC 0x1E,1
	RCALL SUBOPT_0x1C
;     263                                 printf("\r\n\r\nADDRESS ERROR\r\n");
	RCALL SUBOPT_0x20
;     264                                 goto GT; 
	RJMP _0x24
;     265                         };
_0x3A:
;     266                         
;     267                         for (j=0; j==16; j++) attmp[j]=0;
	LDI  R18,LOW(0)
_0x3F:
	CPI  R18,16
	BRNE _0x40
	RCALL SUBOPT_0x21
	LDI  R30,LOW(0)
	ST   X,R30
;     268                         j=0;
	SUBI R18,-1
	RJMP _0x3F
_0x40:
	LDI  R18,LOW(0)
;     269 
;     270                         while (rx_buffer0[i+10]!=NULL)
_0x41:
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x22
	CPI  R30,0
	BREQ _0x43
;     271                         {
;     272                                 attmp[j]=rx_buffer0[i+10];
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x22
	ST   X,R30
;     273                                 if (!( (isdigit(attmp[j])) || (isxdigit(attmp[j])) )) goto GD;
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0x19
	BRNE _0x45
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0x1A
	BREQ _0x46
_0x45:
	RJMP _0x44
_0x46:
	RJMP _0x39
;     274                                 i++;
_0x44:
	SUBI R17,-1
;     275                                 j++;
	SUBI R18,-1
;     276                         };
	RJMP _0x41
_0x43:
;     277                         EEP=hexdec(attmp);
	RCALL SUBOPT_0x23
;     278 
;     279                         eeprom_write(tmpint,EEP);
	RCALL SUBOPT_0x1E
	LDD  R30,Y+9
	ST   -Y,R30
	RCALL _eeprom_write
;     280                         EEP=eeprom_read(tmpint);
	RCALL SUBOPT_0x1E
	RCALL _eeprom_read
	RCALL SUBOPT_0x1F
;     281                         if (ATECHO==1) printf("\r\n\r\n%s",rx_buffer0);
	SBIC 0x1E,1
	RCALL SUBOPT_0x1C
;     282                         printf(" \r\n\r\n ADDRESS [0x%X] \r\n VALUE [0x%X] \r\n WRITE OK\r\n\r\n  ",tmpint,EEP);
	RCALL SUBOPT_0x24
;     283                         goto GT;
	RJMP _0x24
;     284                 
;     285                 };
_0x32:
;     286                 
;     287                 
;     288                 //-------External EEPROM read-----------
;     289                 scmptmp=strncmpf(rx_buffer0,AT_EEEPR,9);
	RCALL SUBOPT_0x13
	LDI  R30,LOW(_AT_EEEPR*2)
	LDI  R31,HIGH(_AT_EEEPR*2)
	RCALL SUBOPT_0x14
;     290                 if (scmptmp==0)
	BRNE _0x48
;     291                 {       
;     292                         while (rx_buffer0[i+9]!=NULL)
_0x49:
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x16
	CPI  R30,0
	BREQ _0x4B
;     293                         {
;     294                                 attmp[i]=rx_buffer0[i+9];
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x18
;     295                                 if (!( (isdigit(attmp[i])) || (isxdigit(attmp[i])) )) goto FX;
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0x19
	BRNE _0x4D
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0x1A
	BREQ _0x4E
_0x4D:
	RJMP _0x4C
_0x4E:
	RJMP _0x4F
;     296                                 i++;
_0x4C:
	SUBI R17,-1
;     297                         };
	RJMP _0x49
_0x4B:
;     298 
;     299                         tmpint=hexdec(attmp);  
	RCALL SUBOPT_0x1B
;     300                         
;     301                         //printf(" \r\n \r\n tmpint=hexdec(attmp); \r\n - attmp = %s \r\n ",attmp);
;     302                         //printf(" \r\n - tmpint = %X \r\n ",tmpint);
;     303                         
;     304                         if ((tmpint<0)||(tmpint>MAX_EXT_EEPROM))
	BRLO _0x51
	__CPWRN 19,20,16384
	BRLO _0x50
_0x51:
;     305                         {
;     306 FX:
_0x4F:
;     307                                 if (ATECHO==1) printf("\r\n\r\n%s",rx_buffer0);
	SBIC 0x1E,1
	RCALL SUBOPT_0x1C
;     308                                 printf("\r\n\r\nVALUE ERROR\r\n");
	RCALL SUBOPT_0x1D
;     309                                 goto GT; 
	RJMP _0x24
;     310                         };
_0x50:
;     311                         
;     312                         EEP=ext_eeprom_read(tmpint);
	RCALL SUBOPT_0x25
;     313                         if (ATECHO==1) printf(" \r\n\r\n%s ",rx_buffer0);
	SBIC 0x1E,1
	RCALL SUBOPT_0x12
;     314                         printf(" \r\n+EEEPR=0x%X\r\n\r\nOK\r\n ",EEP);
	__POINTW1FN _0,201
	RCALL SUBOPT_0x1
	LDD  R30,Y+9
	LDD  R31,Y+9+1
	RJMP _0xDA
;     315                         goto GT;    
;     316                 };
_0x48:
;     317                 
;     318                 //-------External EEPROM write----------
;     319                 scmptmp=strncmpf(rx_buffer0,AT_EEEPW,9);
	RCALL SUBOPT_0x13
	LDI  R30,LOW(_AT_EEEPW*2)
	LDI  R31,HIGH(_AT_EEEPW*2)
	RCALL SUBOPT_0x14
;     320                 if (scmptmp==0)
	BREQ PC+2
	RJMP _0x55
;     321                 { 
;     322                         while (rx_buffer0[i+9]!=',')
_0x56:
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x16
	CPI  R30,LOW(0x2C)
	BREQ _0x58
;     323                         {
;     324                                 attmp[i]=rx_buffer0[i+9];
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x18
;     325                                 if (!( (isdigit(attmp[i])) || (isxdigit(attmp[i])) )) goto GW;
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0x19
	BRNE _0x5A
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0x1A
	BREQ _0x5B
_0x5A:
	RJMP _0x59
_0x5B:
	RJMP _0x5C
;     326                                 i++;
_0x59:
	SUBI R17,-1
;     327                         };
	RJMP _0x56
_0x58:
;     328                         tmpint=hexdec(attmp);
	RCALL SUBOPT_0x1B
;     329                         
;     330                         if ((tmpint<0)||(tmpint>MAX_EXT_EEPROM))
	BRLO _0x5E
	__CPWRN 19,20,16384
	BRLO _0x5D
_0x5E:
;     331                         {
;     332 GW:
_0x5C:
;     333                                 if (ATECHO==1) printf("\r\n\r\n%s",rx_buffer0);
	SBIC 0x1E,1
	RCALL SUBOPT_0x1C
;     334                                 printf("\r\n\r\nADDRESS ERROR\r\n");
	RCALL SUBOPT_0x20
;     335                                 goto GT; 
	RJMP _0x24
;     336                         };
_0x5D:
;     337                         
;     338                         for (j=0; j==16; j++) attmp[j]=0;
	LDI  R18,LOW(0)
_0x62:
	CPI  R18,16
	BRNE _0x63
	RCALL SUBOPT_0x21
	LDI  R30,LOW(0)
	ST   X,R30
;     339                         j=0;
	SUBI R18,-1
	RJMP _0x62
_0x63:
	LDI  R18,LOW(0)
;     340 
;     341                         while (rx_buffer0[i+10]!=NULL)
_0x64:
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x22
	CPI  R30,0
	BREQ _0x66
;     342                         {
;     343                                 attmp[j]=rx_buffer0[i+10];
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x22
	ST   X,R30
;     344                                 if (!( (isdigit(attmp[j])) || (isxdigit(attmp[j])) )) goto GD;
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0x19
	BRNE _0x68
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0x1A
	BREQ _0x69
_0x68:
	RJMP _0x67
_0x69:
	RJMP _0x39
;     345                                 i++;
_0x67:
	SUBI R17,-1
;     346                                 j++;
	SUBI R18,-1
;     347                         };
	RJMP _0x64
_0x66:
;     348                         EEP=hexdec(attmp);
	RCALL SUBOPT_0x23
;     349 
;     350                         ext_eeprom_write(tmpint,EEP);
	ST   -Y,R19
	LDD  R30,Y+8
	ST   -Y,R30
	RCALL _ext_eeprom_write
;     351                         EEP=ext_eeprom_read(tmpint);
	RCALL SUBOPT_0x25
;     352                         if (ATECHO==1) printf("\r\n\r\n%s",rx_buffer0);
	SBIC 0x1E,1
	RCALL SUBOPT_0x1C
;     353                         printf(" \r\n\r\n ADDRESS [0x%X] \r\n VALUE [0x%X] \r\n WRITE OK\r\n\r\n  ",tmpint,EEP);
	RCALL SUBOPT_0x24
;     354                         goto GT;
	RJMP _0x24
;     355                 
;     356                 };
_0x55:
;     357                 
;     358                 printf(" \r\n\r\n%s\r\n\r\nERROR\r\n ",rx_buffer0);
	__POINTW1FN _0,225
_0xD9:
	ST   -Y,R31
	ST   -Y,R30
	RCALL SUBOPT_0x10
_0xDA:
	CLR  R22
	CLR  R23
	RCALL SUBOPT_0x26
;     359 
;     360                 //-------------AT COMMAND SECTOR END-----------------
;     361 GT:
_0x24:
;     362                 rx_counter0=0;
	RCALL SUBOPT_0xD
;     363                 rx_wr_index0=0;
;     364                 tmpint=0;
;     365                 for (i=0; i==RX_BUFFER_SIZE0; i++) rx_buffer0[i]=0;
_0x6C:
	CPI  R17,32
	BRNE _0x6D
	RCALL SUBOPT_0xE
;     366                 for (i=0; i==16; i++) attmp[i]=0;
	SUBI R17,-1
	RJMP _0x6C
_0x6D:
	LDI  R17,LOW(0)
_0x6F:
	CPI  R17,16
	BRNE _0x70
	RCALL SUBOPT_0xF
;     367         };
	SUBI R17,-1
	RJMP _0x6F
_0x70:
_0x21:
;     368         
;     369         printf("%c",data);
	__POINTW1FN _0,245
	RCALL SUBOPT_0x1
	LDD  R30,Y+8
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL SUBOPT_0x26
;     370    };
_0x12:
;     371 }
	RCALL __LOADLOCR6
	ADIW R28,25
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;     372 
;     373 #pragma warn+
;     374 
;     375 // Timer 0 overflow interrupt service routine
;     376 interrupt [TIM0_OVF] void timer0_ovf_isr(void)
;     377 {
_timer0_ovf_isr:
;     378 // Place your code here
;     379 
;     380 }
	RETI
;     381 
;     382 // Declare your global variables here
;     383 
;     384 void main(void)
;     385 {
_main:
;     386 // Declare your local variables here
;     387 
;     388 // Crystal Oscillator division factor: 1
;     389 #pragma optsize-
;     390 CLKPR=0x80;
	LDI  R30,LOW(128)
	STS  97,R30
;     391 CLKPR=0x00;
	LDI  R30,LOW(0)
	STS  97,R30
;     392 #ifdef _OPTIMIZE_SIZE_
;     393 #pragma optsize+
;     394 #endif
;     395 
;     396 // Input/Output Ports initialization
;     397 // Port B initialization
;     398 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
;     399 // State7=P State6=P State5=P State4=P State3=P State2=P State1=P State0=P 
;     400 PORTB=0xFF;
	LDI  R30,LOW(255)
	OUT  0x5,R30
;     401 DDRB=0x00;
	LDI  R30,LOW(0)
	OUT  0x4,R30
;     402 
;     403 // Port C initialization
;     404 // Func6=In Func5=In Func4=In Func3=In Func2=Out Func1=In Func0=In 
;     405 // State6=P State5=P State4=P State3=P State2=0 State1=P State0=P 
;     406 PORTC=0x7B;
	LDI  R30,LOW(123)
	OUT  0x8,R30
;     407 DDRC=0x04;
	LDI  R30,LOW(4)
	OUT  0x7,R30
;     408 
;     409 // Port D initialization
;     410 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
;     411 // State7=P State6=P State5=P State4=P State3=P State2=P State1=P State0=P 
;     412 PORTD=0xFF;
	LDI  R30,LOW(255)
	OUT  0xB,R30
;     413 DDRD=0x00;
	LDI  R30,LOW(0)
	OUT  0xA,R30
;     414 
;     415 // Timer/Counter 0 initialization
;     416 // Clock source: System Clock
;     417 // Clock value: 7,200 kHz
;     418 // Mode: Normal top=FFh
;     419 // OC0A output: Disconnected
;     420 // OC0B output: Disconnected
;     421 TCCR0A=0x00;
	OUT  0x24,R30
;     422 TCCR0B=0x05;
	LDI  R30,LOW(5)
	OUT  0x25,R30
;     423 TCNT0=0x00;
	LDI  R30,LOW(0)
	OUT  0x26,R30
;     424 OCR0A=0x00;
	OUT  0x27,R30
;     425 OCR0B=0x00;
	OUT  0x28,R30
;     426 
;     427 TCCR1A=0x00;
	STS  128,R30
;     428 TCCR1B=0x00;
	STS  129,R30
;     429 TCNT1H=0x00;
	STS  133,R30
;     430 TCNT1L=0x00;
	STS  132,R30
;     431 ICR1H=0x00;
	STS  135,R30
;     432 ICR1L=0x00;
	STS  134,R30
;     433 OCR1AH=0x00;
	STS  137,R30
;     434 OCR1AL=0x00;
	STS  136,R30
;     435 OCR1BH=0x00;
	STS  139,R30
;     436 OCR1BL=0x00;
	STS  138,R30
;     437 
;     438 ASSR=0x00;
	STS  182,R30
;     439 TCCR2A=0x00;
	STS  176,R30
;     440 TCCR2B=0x00;
	STS  177,R30
;     441 TCNT2=0x00;
	STS  178,R30
;     442 OCR2A=0x00;
	STS  179,R30
;     443 OCR2B=0x00;
	STS  180,R30
;     444 
;     445 // External Interrupt(s) initialization
;     446 // INT0: Off
;     447 // INT1: Off
;     448 // Interrupt on any change on pins PCINT0-7: Off
;     449 // Interrupt on any change on pins PCINT8-14: Off
;     450 // Interrupt on any change on pins PCINT16-23: Off
;     451 EICRA=0x00;
	STS  105,R30
;     452 EIMSK=0x00;
	OUT  0x1D,R30
;     453 PCICR=0x00;
	STS  104,R30
;     454 
;     455 // Timer/Counter 0 Interrupt(s) initialization
;     456 TIMSK0=0x01;
	LDI  R30,LOW(1)
	STS  110,R30
;     457 // Timer/Counter 1 Interrupt(s) initialization
;     458 TIMSK1=0x00;
	LDI  R30,LOW(0)
	STS  111,R30
;     459 // Timer/Counter 2 Interrupt(s) initialization
;     460 TIMSK2=0x00;
	STS  112,R30
;     461 
;     462 // USART initialization
;     463 // Communication Parameters: 8 Data, 1 Stop, No Parity
;     464 // USART Receiver: On
;     465 // USART Transmitter: On
;     466 // USART0 Mode: Asynchronous
;     467 // USART Baud rate: 9600
;     468 UCSR0A=0x00;
	STS  192,R30
;     469 UCSR0B=0x98;
	LDI  R30,LOW(152)
	STS  193,R30
;     470 UCSR0C=0x06;
	LDI  R30,LOW(6)
	STS  194,R30
;     471 UBRR0H=0x00;
	LDI  R30,LOW(0)
	STS  197,R30
;     472 UBRR0L=0x2F;
	LDI  R30,LOW(47)
	STS  196,R30
;     473 
;     474 // Analog Comparator initialization
;     475 // Analog Comparator: Off
;     476 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     477 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x30,R30
;     478 ADCSRB=0x00;
	LDI  R30,LOW(0)
	STS  123,R30
;     479 
;     480 // Global enable interrupts
;     481 #asm("sei")
	sei
;     482 
;     483 i2c_init();
	RCALL _i2c_init
;     484 PORTC.2=1;
	SBI  0x8,2
;     485 
;     486 while (1)
_0x71:
;     487       {
;     488       // Place your code here
;     489       
;     490 
;     491       };
	RJMP _0x71
;     492 }
_0x74:
	RJMP _0x74

_putchar:
_0x78:
	LDS  R30,192
	ANDI R30,LOW(0x20)
	BREQ _0x78
	LD   R30,Y
	STS  198,R30
	ADIW R28,1
	RET
__put_G2:
	LD   R26,Y
	LDD  R27,Y+1
	RCALL __GETW1P
	SBIW R30,0
	BREQ _0x7B
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	SBIW R30,1
	LDD  R26,Y+2
	STD  Z+0,R26
	RJMP _0x7C
_0x7B:
	LDD  R30,Y+2
	ST   -Y,R30
	RCALL _putchar
_0x7C:
	ADIW R28,3
	RET
__print_G2:
	SBIW R28,6
	RCALL __SAVELOCR6
	LDI  R16,0
_0x7D:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	ADIW R30,1
	STD  Y+16,R30
	STD  Y+16+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R19,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0x7F
	MOV  R30,R16
	CPI  R30,0
	BRNE _0x83
	CPI  R19,37
	BRNE _0x84
	LDI  R16,LOW(1)
	RJMP _0x85
_0x84:
	RCALL SUBOPT_0x27
_0x85:
	RJMP _0x82
_0x83:
	CPI  R30,LOW(0x1)
	BRNE _0x86
	CPI  R19,37
	BRNE _0x87
	RCALL SUBOPT_0x27
	RJMP _0xDB
_0x87:
	LDI  R16,LOW(2)
	LDI  R21,LOW(0)
	LDI  R17,LOW(0)
	CPI  R19,45
	BRNE _0x88
	LDI  R17,LOW(1)
	RJMP _0x82
_0x88:
	CPI  R19,43
	BRNE _0x89
	LDI  R21,LOW(43)
	RJMP _0x82
_0x89:
	CPI  R19,32
	BRNE _0x8A
	LDI  R21,LOW(32)
	RJMP _0x82
_0x8A:
	RJMP _0x8B
_0x86:
	CPI  R30,LOW(0x2)
	BRNE _0x8C
_0x8B:
	LDI  R20,LOW(0)
	LDI  R16,LOW(3)
	CPI  R19,48
	BRNE _0x8D
	ORI  R17,LOW(128)
	RJMP _0x82
_0x8D:
	RJMP _0x8E
_0x8C:
	CPI  R30,LOW(0x3)
	BREQ PC+2
	RJMP _0x82
_0x8E:
	CPI  R19,48
	BRLO _0x91
	CPI  R19,58
	BRLO _0x92
_0x91:
	RJMP _0x90
_0x92:
	MOV  R26,R20
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOVW R30,R0
	MOV  R20,R30
	MOV  R30,R19
	SUBI R30,LOW(48)
	ADD  R20,R30
	RJMP _0x82
_0x90:
	MOV  R30,R19
	CPI  R30,LOW(0x63)
	BRNE _0x96
	RCALL SUBOPT_0x28
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0x29
	RJMP _0x97
_0x96:
	CPI  R30,LOW(0x73)
	BRNE _0x99
	RCALL SUBOPT_0x28
	RCALL SUBOPT_0x2A
	RCALL _strlen
	MOV  R16,R30
	RJMP _0x9A
_0x99:
	CPI  R30,LOW(0x70)
	BRNE _0x9C
	RCALL SUBOPT_0x28
	RCALL SUBOPT_0x2A
	RCALL _strlenf
	MOV  R16,R30
	ORI  R17,LOW(8)
_0x9A:
	ORI  R17,LOW(2)
	ANDI R17,LOW(127)
	LDI  R18,LOW(0)
	RJMP _0x9D
_0x9C:
	CPI  R30,LOW(0x64)
	BREQ _0xA0
	CPI  R30,LOW(0x69)
	BRNE _0xA1
_0xA0:
	ORI  R17,LOW(4)
	RJMP _0xA2
_0xA1:
	CPI  R30,LOW(0x75)
	BRNE _0xA3
_0xA2:
	LDI  R30,LOW(_tbl10_G2*2)
	LDI  R31,HIGH(_tbl10_G2*2)
	RCALL SUBOPT_0x2B
	LDI  R16,LOW(5)
	RJMP _0xA4
_0xA3:
	CPI  R30,LOW(0x58)
	BRNE _0xA6
	ORI  R17,LOW(8)
	RJMP _0xA7
_0xA6:
	CPI  R30,LOW(0x78)
	BREQ PC+2
	RJMP _0xD8
_0xA7:
	LDI  R30,LOW(_tbl16_G2*2)
	LDI  R31,HIGH(_tbl16_G2*2)
	RCALL SUBOPT_0x2B
	LDI  R16,LOW(4)
_0xA4:
	SBRS R17,2
	RJMP _0xA9
	RCALL SUBOPT_0x28
	RCALL __GETW1P
	RCALL SUBOPT_0x2C
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,0
	BRGE _0xAA
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	RCALL __ANEGW1
	RCALL SUBOPT_0x2C
	LDI  R21,LOW(45)
_0xAA:
	CPI  R21,0
	BREQ _0xAB
	SUBI R16,-LOW(1)
	RJMP _0xAC
_0xAB:
	ANDI R17,LOW(251)
_0xAC:
	RJMP _0xAD
_0xA9:
	RCALL SUBOPT_0x28
	RCALL __GETW1P
	RCALL SUBOPT_0x2C
_0xAD:
_0x9D:
	SBRC R17,0
	RJMP _0xAE
_0xAF:
	CP   R16,R20
	BRSH _0xB1
	SBRS R17,7
	RJMP _0xB2
	SBRS R17,2
	RJMP _0xB3
	ANDI R17,LOW(251)
	MOV  R19,R21
	SUBI R16,LOW(1)
	RJMP _0xB4
_0xB3:
	LDI  R19,LOW(48)
_0xB4:
	RJMP _0xB5
_0xB2:
	LDI  R19,LOW(32)
_0xB5:
	RCALL SUBOPT_0x27
	SUBI R20,LOW(1)
	RJMP _0xAF
_0xB1:
_0xAE:
	MOV  R18,R16
	SBRS R17,1
	RJMP _0xB6
_0xB7:
	CPI  R18,0
	BREQ _0xB9
	SBRS R17,3
	RJMP _0xBA
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	RCALL SUBOPT_0x2B
	SBIW R30,1
	LPM  R30,Z
	RJMP _0xDC
_0xBA:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0xDC:
	ST   -Y,R30
	RCALL SUBOPT_0x29
	CPI  R20,0
	BREQ _0xBC
	SUBI R20,LOW(1)
_0xBC:
	SUBI R18,LOW(1)
	RJMP _0xB7
_0xB9:
	RJMP _0xBD
_0xB6:
_0xBF:
	LDI  R19,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	RCALL SUBOPT_0x2B
	SBIW R30,2
	RCALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
_0xC1:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0xC3
	SUBI R19,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	RCALL SUBOPT_0x2C
	RJMP _0xC1
_0xC3:
	CPI  R19,58
	BRLO _0xC4
	SBRS R17,3
	RJMP _0xC5
	SUBI R19,-LOW(7)
	RJMP _0xC6
_0xC5:
	SUBI R19,-LOW(39)
_0xC6:
_0xC4:
	SBRC R17,4
	RJMP _0xC8
	CPI  R19,49
	BRSH _0xCA
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0xC9
_0xCA:
	RJMP _0xDD
_0xC9:
	CP   R20,R18
	BRLO _0xCE
	SBRS R17,0
	RJMP _0xCF
_0xCE:
	RJMP _0xCD
_0xCF:
	LDI  R19,LOW(32)
	SBRS R17,7
	RJMP _0xD0
	LDI  R19,LOW(48)
_0xDD:
	ORI  R17,LOW(16)
	SBRS R17,2
	RJMP _0xD1
	ANDI R17,LOW(251)
	ST   -Y,R21
	RCALL SUBOPT_0x29
	CPI  R20,0
	BREQ _0xD2
	SUBI R20,LOW(1)
_0xD2:
_0xD1:
_0xD0:
_0xC8:
	RCALL SUBOPT_0x27
	CPI  R20,0
	BREQ _0xD3
	SUBI R20,LOW(1)
_0xD3:
_0xCD:
	SUBI R18,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRLO _0xC0
	RJMP _0xBF
_0xC0:
_0xBD:
	SBRS R17,0
	RJMP _0xD4
_0xD5:
	CPI  R20,0
	BREQ _0xD7
	SUBI R20,LOW(1)
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL SUBOPT_0x29
	RJMP _0xD5
_0xD7:
_0xD4:
_0xD8:
_0x97:
_0xDB:
	LDI  R16,LOW(0)
_0x82:
	RJMP _0x7D
_0x7F:
	RCALL __LOADLOCR6
	ADIW R28,18
	RET
_printf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,2
	RCALL __SAVELOCR2
	MOVW R26,R28
	RCALL __ADDW2R15
	MOVW R16,R26
	LDI  R30,0
	STD  Y+2,R30
	STD  Y+2+1,R30
	MOVW R26,R28
	ADIW R26,4
	RCALL __ADDW2R15
	RCALL __GETW1P
	RCALL SUBOPT_0x1
	ST   -Y,R17
	ST   -Y,R16
	MOVW R30,R28
	ADIW R30,6
	RCALL SUBOPT_0x1
	RCALL __print_G2
	RCALL __LOADLOCR2
	ADIW R28,4
	POP  R15
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x0:
	ST   -Y,R30
	RJMP _i2c_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 50 TIMES, CODE SIZE REDUCTION:47 WORDS
SUBOPT_0x1:
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 36 TIMES, CODE SIZE REDUCTION:68 WORDS
SUBOPT_0x2:
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x3:
	CLR  R22
	CLR  R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4:
	__PUTD1S 20
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x5:
	__GETD2S 20
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x6:
	__GETD1S 20
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x7:
	__PUTD1S 12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x8:
	__GETD1S 16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 24 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x9:
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0xA:
	LD   R30,X
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0xB:
	__GETD1S 14
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:34 WORDS
SUBOPT_0xC:
	RCALL SUBOPT_0x3
	RCALL __PUTPARD1
	LDI  R24,4
	RCALL _printf
	ADIW R28,6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0xD:
	CLR  R3
	CLR  R2
	__GETWRN 19,20,0
	LDI  R17,LOW(0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0xE:
	MOV  R26,R17
	LDI  R27,0
	SUBI R26,LOW(-_rx_buffer0)
	SBCI R27,HIGH(-_rx_buffer0)
	LDI  R30,LOW(0)
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0xF:
	MOV  R30,R17
	RCALL SUBOPT_0x2
	MOVW R26,R28
	ADIW R26,9
	RCALL SUBOPT_0x9
	LDI  R30,LOW(0)
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x10:
	LDI  R30,LOW(_rx_buffer0)
	LDI  R31,HIGH(_rx_buffer0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x11:
	MOV  R16,R30
	CPI  R16,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x12:
	__POINTW1FN _0,57
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x10
	RJMP SUBOPT_0xC

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x13:
	RCALL SUBOPT_0x10
	RJMP SUBOPT_0x1

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x14:
	RCALL SUBOPT_0x1
	LDI  R30,LOW(9)
	ST   -Y,R30
	RCALL _strncmpf
	RJMP SUBOPT_0x11

;OPTIMIZER ADDED SUBROUTINE, CALLED 20 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x15:
	MOV  R30,R17
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x16:
	__ADDW1MN _rx_buffer0,9
	LD   R30,Z
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 20 TIMES, CODE SIZE REDUCTION:36 WORDS
SUBOPT_0x17:
	MOVW R26,R28
	ADIW R26,9
	RJMP SUBOPT_0x9

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x18:
	ST   X,R30
	RJMP SUBOPT_0x15

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x19:
	RCALL _isdigit
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1A:
	RCALL _isxdigit
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x1B:
	MOVW R30,R28
	ADIW R30,9
	RCALL SUBOPT_0x1
	RCALL _hexdec
	__PUTW1R 19,20
	SUBI R19,0
	SBCI R20,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x1C:
	__POINTW1FN _0,77
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x10
	RJMP SUBOPT_0xC

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1D:
	__POINTW1FN _0,84
	RCALL SUBOPT_0x1
	LDI  R24,0
	RCALL _printf
	ADIW R28,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1E:
	ST   -Y,R20
	ST   -Y,R19
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1F:
	STD  Y+7,R30
	STD  Y+7+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x20:
	__POINTW1FN _0,126
	RCALL SUBOPT_0x1
	LDI  R24,0
	RCALL _printf
	ADIW R28,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x21:
	MOV  R30,R18
	RCALL SUBOPT_0x2
	RJMP SUBOPT_0x17

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x22:
	__ADDW1MN _rx_buffer0,10
	LD   R30,Z
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x23:
	MOVW R30,R28
	ADIW R30,9
	RCALL SUBOPT_0x1
	RCALL _hexdec
	RJMP SUBOPT_0x1F

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x24:
	__POINTW1FN _0,146
	RCALL SUBOPT_0x1
	__GETW1R 19,20
	RCALL SUBOPT_0x3
	RCALL __PUTPARD1
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	RCALL SUBOPT_0x3
	RCALL __PUTPARD1
	LDI  R24,8
	RCALL _printf
	ADIW R28,10
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x25:
	RCALL SUBOPT_0x1E
	RCALL _ext_eeprom_read
	RCALL SUBOPT_0x2
	RJMP SUBOPT_0x1F

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x26:
	RCALL __PUTPARD1
	LDI  R24,4
	RCALL _printf
	ADIW R28,6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x27:
	ST   -Y,R19
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	RCALL SUBOPT_0x1
	RJMP __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x28:
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	SBIW R26,4
	STD  Y+14,R26
	STD  Y+14+1,R27
	ADIW R26,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x29:
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	RCALL SUBOPT_0x1
	RJMP __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2A:
	RCALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	RJMP SUBOPT_0x1

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2B:
	STD  Y+6,R30
	STD  Y+6+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2C:
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

	.equ __i2c_dir=__i2c_port-1
	.equ __i2c_pin=__i2c_port-2
_i2c_init:
	cbi  __i2c_port,__scl_bit
	cbi  __i2c_port,__sda_bit
	sbi  __i2c_dir,__scl_bit
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay2
_i2c_start:
	cbi  __i2c_dir,__sda_bit
	cbi  __i2c_dir,__scl_bit
	clr  r30
	nop
	sbis __i2c_pin,__sda_bit
	ret
	sbis __i2c_pin,__scl_bit
	ret
	rcall __i2c_delay1
	sbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	ldi  r30,1
__i2c_delay1:
	ldi  r22,12
	rjmp __i2c_delay2l
_i2c_stop:
	sbi  __i2c_dir,__sda_bit
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
__i2c_delay2:
	ldi  r22,25
__i2c_delay2l:
	dec  r22
	brne __i2c_delay2l
	ret
_i2c_read:
	ldi  r23,8
__i2c_read0:
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
__i2c_read3:
	sbis __i2c_pin,__scl_bit
	rjmp __i2c_read3
	rcall __i2c_delay1
	clc
	sbic __i2c_pin,__sda_bit
	sec
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	rol  r30
	dec  r23
	brne __i2c_read0
	ld   r23,y+
	tst  r23
	brne __i2c_read1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_read2
__i2c_read1:
	sbi  __i2c_dir,__sda_bit
__i2c_read2:
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay1

_i2c_write:
	ld   r30,y+
	ldi  r23,8
__i2c_write0:
	lsl  r30
	brcc __i2c_write1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_write2
__i2c_write1:
	sbi  __i2c_dir,__sda_bit
__i2c_write2:
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
__i2c_write3:
	sbis __i2c_pin,__scl_bit
	rjmp __i2c_write3
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	dec  r23
	brne __i2c_write0
	cbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	ldi  r30,1
	sbic __i2c_pin,__sda_bit
	clr  r30
	sbi  __i2c_dir,__scl_bit
	ret

_isdigit:
	ldi  r30,1
	ld   r31,y+
	cpi  r31,'0'
	brlo __isdigit0
	cpi  r31,'9'+1
	brlo __isdigit1
__isdigit0:
	clr  r30
__isdigit1:
	ret

_isxdigit:
	ldi  r30,1
	ld   r31,y+
	subi r31,0x30
	brcs __isxdigit0
	cpi  r31,10
	brcs __isxdigit1
	andi r31,0x5f
	subi r31,7
	cpi  r31,10
	brcs __isxdigit0
	cpi  r31,16
	brcs __isxdigit1
__isxdigit0:
	clr  r30
__isxdigit1:
	ret

_strcmpf:
	ld   r30,y+
	ld   r31,y+
	ld   r26,y+
	ld   r27,y+
__strcmpf0:
	ld   r1,x+
	lpm  r0,z+
	cp   r0,r1
	brne __strcmpf1
	tst  r0
	brne __strcmpf0
__strcmpf3:
	clr  r30
	ret
__strcmpf1:
	sub  r1,r0
	breq __strcmpf3
	ldi  r30,1
	brcc __strcmpf2
	subi r30,2
__strcmpf2:
	ret

_strlen:
	ld   r26,y+
	ld   r27,y+
	clr  r30
	clr  r31
__strlen0:
	ld   r22,x+
	tst  r22
	breq __strlen1
	adiw r30,1
	rjmp __strlen0
__strlen1:
	ret

_strlenf:
	clr  r26
	clr  r27
	ld   r30,y+
	ld   r31,y+
__strlenf0:
	lpm  r0,z+
	tst  r0
	breq __strlenf1
	adiw r26,1
	rjmp __strlenf0
__strlenf1:
	movw r30,r26
	ret

_strncmpf:
	clr  r0
	clr  r1
	ld   r22,y+
	ld   r30,y+
	ld   r31,y+
	ld   r26,y+
	ld   r27,y+
__strncmpf0:
	tst  r22
	breq __strncmpf1
	dec  r22
	ld   r1,x+
	lpm  r0,z+
	cp   r0,r1
	brne __strncmpf1
	tst  r0
	brne __strncmpf0
__strncmpf3:
	clr  r30
	ret
__strncmpf1:
	sub  r1,r0
	breq __strncmpf3
	ldi  r30,1
	brcc __strncmpf2
	subi r30,2
__strncmpf2:
	ret

_toint:
	ld   r30,y+
	subi r30,'0'
	brcs __toint0
	cpi  r30,10
	brcs __toint1
	andi r30,0xdf
	subi r30,7
	cpi  r30,10
	brcs __toint0
	cpi  r30,16
	brcs __toint1
__toint0:
	clr  r30
__toint1:
	ret

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x733
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ADDD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	ADC  R23,R25
	RET

__ANEGW1:
	COM  R30
	COM  R31
	ADIW R30,1
	RET

__ANEGD1:
	COM  R30
	COM  R31
	COM  R22
	COM  R23
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__LSLW4:
	LSL  R30
	ROL  R31
__LSLW3:
	LSL  R30
	ROL  R31
__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__LSRW4:
	LSR  R31
	ROR  R30
__LSRW3:
	LSR  R31
	ROR  R30
__LSRW2:
	LSR  R31
	ROR  R30
	LSR  R31
	ROR  R30
	RET

__MULD12U:
	MUL  R23,R26
	MOV  R23,R0
	MUL  R22,R27
	ADD  R23,R0
	MUL  R31,R24
	ADD  R23,R0
	MUL  R30,R25
	ADD  R23,R0
	MUL  R22,R26
	MOV  R22,R0
	ADD  R23,R1
	MUL  R31,R27
	ADD  R22,R0
	ADC  R23,R1
	MUL  R30,R24
	ADD  R22,R0
	ADC  R23,R1
	CLR  R24
	MUL  R31,R26
	MOV  R31,R0
	ADD  R22,R1
	ADC  R23,R24
	MUL  R30,R27
	ADD  R31,R0
	ADC  R22,R1
	ADC  R23,R24
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	ADC  R22,R24
	ADC  R23,R24
	RET

__MULD12:
	RCALL __CHKSIGND
	RCALL __MULD12U
	BRTC __MULD121
	RCALL __ANEGD1
__MULD121:
	RET

__CHKSIGND:
	CLT
	SBRS R23,7
	RJMP __CHKSD1
	RCALL __ANEGD1
	SET
__CHKSD1:
	SBRS R25,7
	RJMP __CHKSD2
	CLR  R0
	COM  R26
	COM  R27
	COM  R24
	COM  R25
	ADIW R26,1
	ADC  R24,R0
	ADC  R25,R0
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSD2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__CPD10:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	RET

__CPD20:
	SBIW R26,0
	SBCI R24,0
	SBCI R25,0
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__INITLOCB:
__INITLOCW:
	ADD R26,R28
	ADC R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

;END OF CODE MARKER
__END_OF_CODE:
