// CodeVisionAVR C Compiler
// (C) 1998-2004 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATmega48(V)


#pragma used+
sfrb PINB=3;
sfrb DDRB=4;
sfrb PORTB=5;
sfrb PINC=6;
sfrb DDRC=7;
sfrb PORTC=8;
sfrb PIND=9;
sfrb DDRD=0xa;
sfrb PORTD=0xb;
sfrb TIFR0=0x15;
sfrb TIFR1=0x16;
sfrb TIFR2=0x17;
sfrb PCIFR=0x1b;
sfrb EIFR=0x1c;
sfrb EIMSK=0x1d;
sfrb GPIOR0=0x1e;
sfrb EECR=0x1f;
sfrb EEDR=0x20;
sfrb EEARL=0x21;
sfrb EEARH=0x22;
sfrw EEAR=0x21;   // 16 bit access
sfrb GTCCR=0x23;
sfrb TCCR0A=0x24;
sfrb TCCR0B=0x25;
sfrb TCNT0=0x26;
sfrb OCR0A=0x27;
sfrb OCR0B=0x28;
sfrb GPIOR1=0x2a;
sfrb GPIOR2=0x2b;
sfrb SPCR=0x2c;
sfrb SPSR=0x2d;
sfrb SPDR=0x2e;
sfrb ACSR=0x30;
sfrb MONDR=0x31;
sfrb SMCR=0x33;
sfrb MCUSR=0x34;
sfrb MCUCR=0x35;
sfrb SPMCSR=0x37;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-


// Interrupt vectors definitions



// CodeVisionAVR C Compiler
// (C) 1998-2003 Pavel Haiduc, HP InfoTech S.R.L.

// Prototypes for standard I/O functions


// CodeVisionAVR C Compiler
// (C) 1998-2002 Pavel Haiduc, HP InfoTech S.R.L.

// Variable length argument list macros



typedef char *va_list;





#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);


char *gets(char *str,unsigned int len);

void printf(char flash *fmtstr,...);
void sprintf(char *str, char flash *fmtstr,...);
void vprintf (char flash * fmtstr, va_list argptr);
void vsprintf (char *str, char flash * fmtstr, va_list argptr);
signed char scanf(char flash *fmtstr,...);
signed char sscanf(char *str, char flash *fmtstr,...);




                                   

            


#pragma used-

#pragma library stdio.lib


/* CodeVisionAVR C Compiler
   Prototypes for standard library functions

   (C) 1998-2003 Pavel Haiduc, HP InfoTech S.R.L.
*/




#pragma used+

int atoi(char *str);
long int atol(char *str);
float atof(char *str);
void itoa(int n,char *str);
void ltoa(long int n,char *str);
void ftoa(float n,unsigned char decimals,char *str);
void ftoe(float n,unsigned char decimals,char *str);
void srand(int seed);
int rand(void);
void *malloc(unsigned int size);
void *calloc(unsigned int num, unsigned int size);
void *realloc(void *ptr, unsigned int size); 
void free(void *ptr);

#pragma used-
#pragma library stdlib.lib


// CodeVisionAVR C Compiler
// (C) 1998-2005 Pavel Haiduc, HP InfoTech S.R.L.

// Prototypes for string functions



#pragma used+

char *strcat(char *str1,char *str2);
char *strcatf(char *str1,char flash *str2);
char *strchr(char *str,char c);
signed char strcmp(char *str1,char *str2);
signed char strcmpf(char *str1,char flash *str2);
char *strcpy(char *dest,char *src);
char *strcpyf(char *dest,char flash *src);
unsigned char strcspn(char *str,char *set);
unsigned char strcspnf(char *str,char flash *set);
unsigned int strlenf(char flash *str);
char *strncat(char *str1,char *str2,unsigned char n);
char *strncatf(char *str1,char flash *str2,unsigned char n);
signed char strncmp(char *str1,char *str2,unsigned char n);
signed char strncmpf(char *str1,char flash *str2,unsigned char n);
char *strncpy(char *dest,char *src,unsigned char n);
char *strncpyf(char *dest,char flash *src,unsigned char n);
char *strpbrk(char *str,char *set);
char *strpbrkf(char *str,char flash *set);
signed char strpos(char *str,char c);
char *strrchr(char *str,char c);
char *strrpbrk(char *str,char *set);
char *strrpbrkf(char *str,char flash *set);
signed char strrpos(char *str,char c);
char *strstr(char *str1,char *str2);
char *strstrf(char *str1,char flash *str2);
unsigned char strspn(char *str,char *set);
unsigned char strspnf(char *str,char flash *set);
char *strtok(char *str1,char flash *str2);
 

unsigned int strlen(char *str);
void *memccpy(void *dest,void *src,char c,unsigned n);
void *memchr(void *buf,unsigned char c,unsigned n);
signed char memcmp(void *buf1,void *buf2,unsigned n);
signed char memcmpf(void *buf1,void flash *buf2,unsigned n);
void *memcpy(void *dest,void *src,unsigned n);
void *memcpyf(void *dest,void flash *src,unsigned n);
void *memmove(void *dest,void *src,unsigned n);
void *memset(void *buf,unsigned char c,unsigned n);

#pragma used-
#pragma library string.lib


// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.

// Prototypes for character type functions


#pragma used+

unsigned char isalnum(char c);
unsigned char isalpha(char c);
unsigned char isascii(char c);
unsigned char iscntrl(char c);
unsigned char isdigit(char c);
unsigned char islower(char c);
unsigned char isprint(char c);
unsigned char ispunct(char c);
unsigned char isspace(char c);
unsigned char isupper(char c);
unsigned char isxdigit(char c);
unsigned char toint(char c);
char tolower(char c);
char toupper(char c);

#pragma used-


/*
  CodeVisionAVR C Compiler
  (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.

  Prototypes for I2C bus master functions

  BEFORE #include -ING THIS FILE YOU
  MUST DECLARE THE I/O ADDRESS OF THE
  DATA REGISTER OF THE PORT AT WHICH
  THE I2C BUS IS CONNECTED AND
  THE DATA BITS USED FOR SDA & SCL

  EXAMPLE FOR PORTB:

    #asm
        .equ __i2c_port=0x18
        .equ __sda_bit=3
        .equ __scl_bit=4
    #endasm
    #include <i2c.h>
*/


#pragma used+
void i2c_init(void);
unsigned char i2c_start(void);
void i2c_stop(void);
unsigned char i2c_read(unsigned char ack);
unsigned char i2c_write(unsigned char data);
#pragma used-


// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.


#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

/*
CodeVisionAVR C Compiler
Prototypes for mathematical functions

Portions (C) 1998-2001 Pavel Haiduc, HP InfoTech S.R.L.
Portions (C) 2000-2001 Yuri G. Salov
*/



#pragma used+

unsigned char cabs(signed char x);
unsigned int abs(int x);
unsigned long labs(long x);
float fabs(float x);
signed char cmax(signed char a,signed char b);
int max(int a,int b);
long lmax(long a,long b);
float fmax(float a,float b);
signed char cmin(signed char a,signed char b);
int min(int a,int b);
long lmin(long a,long b);
float fmin(float a,float b);
signed char csign(signed char x);
signed char sign(int x);
signed char lsign(long x);
signed char fsign(float x);
unsigned char isqrt(unsigned int x);
unsigned int lsqrt(unsigned long x);
float sqrt(float x);
float floor(float x);
float ceil(float x);
float fmod(float x,float y);
float modf(float x,float *ipart);
float ldexp(float x,int expon);
float frexp(float x,int *expon);
float exp(float x);
float log(float x);
float log10(float x);
float pow(float x,float y);
float sin(float x);
float cos(float x);
float tan(float x);
float sinh(float x);
float cosh(float x);
float tanh(float x);
float asin(float x);
float acos(float x);
float atan(float x);
float atan2(float y,float x);

#pragma used-
#pragma library math.lib



// Yak module



unsigned char ext_eeprom_read(unsigned int address) 
{
        unsigned char data, addrh, addrl;
        addrh=(((address<<4)>>12)<<1);
        addrl=(char)address;
        i2c_start();
        i2c_write(0xa0 | addrh);
        i2c_write(addrl);
        i2c_start();
        i2c_write(0xa0 | 1 | addrh);
        data=i2c_read(1);
        i2c_stop();
        return data;
}

void ext_eeprom_write(unsigned char address, unsigned char data) 
{
        i2c_start();
        i2c_write(0xa0);
        i2c_write(address);
        i2c_write(data);
        i2c_stop();
        delay_ms(10);
}

// ================= Write byte to internal EEPROM ===========
void eeprom_write(unsigned int uiAddress, unsigned char ucData)
{
        #asm("cli")
        while(EECR.1);
        EEAR=uiAddress;
        EEDR=ucData;
        EECR.2=1;
        EECR.1=1;
        #asm("sei")
} 

// ================= Read byte from internal EEPROM =========
unsigned int eeprom_read(unsigned int uiAddress)
{       
        #asm("cli")
        while(EECR.1);
        EEAR=uiAddress;
        EECR.0=1;
        return EEDR;
        #asm("sei")
} 

// ================= HEX to DEC conversion ===================
unsigned int hexdec(char* str)
{       
        signed long i,j,a,b,c;
        unsigned int ln=0, tmpint=0;
        ln=strlen(str)-1;
        //printf(" \r\n\r\n unsigned int hexdec(char* str) \r\n - str = %s \r\n ",str);
        //printf(" \r\n - ln = %X \r\n ",ln);
        
        i=ln; j=0;
        while (i>=0)
        { 
                if (i==0) a=1;
                if (i==1) a=0x0F;
                if (i==2) a=0xFF;
                if (i==3) a=0xFFF;
                if (i==4) a=0xFFFF; 
                
                b=toint(str[j]); c=a*b;
                tmpint=tmpint+c;
                printf(" \r\n a = %u ; b = %u ; c = %u ; \r\n ",a,b,c);
                i--; j++;
        }
        
        printf(" \r\n - tmpint = %X \r\n ",tmpint);
        return tmpint;
}

#asm
   .equ __i2c_port=0x0B ;PORTD
   .equ __sda_bit=5
   .equ __scl_bit=6
#endasm
 


// USART Receiver buffer
char rx_buffer0[32];
unsigned char rx_wr_index0,rx_counter0;//,rx_rd_index0;
bit rx_buffer_overflow0;

//AT PROTOCOL
bit ATECHO=1;

flash char AT_C[]="AT";
flash char AT_E0[]="ATE0";
flash char AT_E1[]="ATE1";
flash char AT_INFO[]="AT+INFO";
flash char AT_IEEPR[]="AT+IEEPR=";
flash char AT_IEEPW[]="AT+IEEPW=";
flash char AT_EEEPR[]="AT+EEEPR=";
flash char AT_EEEPW[]="AT+EEEPW=";

#pragma warn-

// USART Receiver interrupt service routine
interrupt [19] void usart_rx_isr(void)
{
signed char scmptmp=-1;
char i=0, j=0;
char attmp[16];
unsigned int tmpint=0,EEP=0;

//unsigned char data;

char status,data;
status=(*(unsigned char *) 0xc0);
data=(*(unsigned char *) 0xc6);
if ((status & ((1<<4) | (1<<2) | (1<<3)))==0)
   {
        rx_buffer0[rx_wr_index0]=data;
        if (++rx_wr_index0 == 32)
        {
                rx_wr_index0=0;
                rx_counter0=0;
                rx_wr_index0=0;
                tmpint=0;
                for (i=0; i==32; i++) rx_buffer0[i]=0;
                for (i=0; i==16; i++) attmp[i]=0;
        };
        if (++rx_counter0 == 32)
        {
                rx_counter0=0;
                rx_buffer_overflow0=1;
                rx_counter0=0;
                rx_wr_index0=0;
                tmpint=0;
                for (i=0; i==32; i++) rx_buffer0[i]=0;
                for (i=0; i==16; i++) attmp[i]=0;
        };
          
        if (data==13)
        {
                rx_buffer0[rx_wr_index0-1]=0;
                
                //==============AT COMMAND SECTOR BEGIN=================
                scmptmp=strcmpf(rx_buffer0,AT_C);
                if (scmptmp==0)
                {
                        if (ATECHO==1) printf(" \r\n\r\n%s ",rx_buffer0);
                        printf(" \r\n\r\nOK\r\n ",rx_buffer0);
                        goto GT;    
                };
 /*               
                //------AT command echo off-------------
                scmptmp=strcmpf(rx_buffer0,AT_E0);
                if (scmptmp==0)
                {
                        if (ATECHO==1) printf(" \r\n\r\n%s ",rx_buffer0);
                        printf(" \r\nCOMMAND ECHO OFF\r\n\r\nOK\r\n ");
                        ATECHO=0;
                        goto GT;    
                };
                
                //------AT command echo on--------------
                scmptmp=strcmpf(rx_buffer0,AT_E1);
                if (scmptmp==0)
                {
                        if (ATECHO==1) printf(" \r\n\r\n%s ",rx_buffer0);
                        printf(" \r\nCOMMAND ECHO ON\r\n\r\nOK\r\n ");
                        ATECHO=1;
                        goto GT;    
                };
                                
                //------Show info-----------------------
                scmptmp=strcmpf(rx_buffer0,AT_INFO);
                if (scmptmp==0)
                {
                        if (ATECHO==1) printf(" \r\n\r\n%s ",rx_buffer0);
                        printf("\r\n ATMEL ATMEGA48 \r\n Max.EEPROM address = 0x%X \r\n Autor: Yak\r\n Date: 07.10.2006\r\n\r\n OK\r\n ",MAX_INT_EEPROM);
                        goto GT;    
                };
 */               
                //-------Internal EEPROM read-----------
                scmptmp=strncmpf(rx_buffer0,AT_IEEPR,9);
                if (scmptmp==0)
                {       
                        while (rx_buffer0[i+9]!=0)
                        {
                                attmp[i]=rx_buffer0[i+9];
                                if (!( (isdigit(attmp[i])) || (isxdigit(attmp[i])) )) goto FD;
                                i++;
                        };
                        tmpint=hexdec(attmp);
                        
                        if ((tmpint<0)||(tmpint>0xFF))
                        {
FD:
                                if (ATECHO==1) printf("\r\n\r\n%s",rx_buffer0);
                                printf("\r\n\r\nVALUE ERROR\r\n");
                                goto GT; 
                        };
                        
                        EEP=eeprom_read(tmpint);
                        if (ATECHO==1) printf(" \r\n\r\n%s ",rx_buffer0);
                        printf(" \r\n+IEEPR=0x%X\r\n\r\nOK\r\n ",EEP);
                        goto GT;    
                };
                
                //-------Internal EEPROM write----------
                scmptmp=strncmpf(rx_buffer0,AT_IEEPW,9);
                if (scmptmp==0)
                { 
                        while (rx_buffer0[i+9]!=',')
                        {
                                attmp[i]=rx_buffer0[i+9];
                                if (!( (isdigit(attmp[i])) || (isxdigit(attmp[i])) )) goto GD;
                                i++;
                        };
                        tmpint=hexdec(attmp);
                        
                        if ((tmpint<0)||(tmpint>0xFF))
                        {
GD:
                                if (ATECHO==1) printf("\r\n\r\n%s",rx_buffer0);
                                printf("\r\n\r\nADDRESS ERROR\r\n");
                                goto GT; 
                        };
                        
                        for (j=0; j==16; j++) attmp[j]=0;
                        j=0;

                        while (rx_buffer0[i+10]!=0)
                        {
                                attmp[j]=rx_buffer0[i+10];
                                if (!( (isdigit(attmp[j])) || (isxdigit(attmp[j])) )) goto GD;
                                i++;
                                j++;
                        };
                        EEP=hexdec(attmp);

                        eeprom_write(tmpint,EEP);
                        EEP=eeprom_read(tmpint);
                        if (ATECHO==1) printf("\r\n\r\n%s",rx_buffer0);
                        printf(" \r\n\r\n ADDRESS [0x%X] \r\n VALUE [0x%X] \r\n WRITE OK\r\n\r\n  ",tmpint,EEP);
                        goto GT;
                
                };
                
                
                //-------External EEPROM read-----------
                scmptmp=strncmpf(rx_buffer0,AT_EEEPR,9);
                if (scmptmp==0)
                {       
                        while (rx_buffer0[i+9]!=0)
                        {
                                attmp[i]=rx_buffer0[i+9];
                                if (!( (isdigit(attmp[i])) || (isxdigit(attmp[i])) )) goto FX;
                                i++;
                        };

                        tmpint=hexdec(attmp);  
                        
                        //printf(" \r\n \r\n tmpint=hexdec(attmp); \r\n - attmp = %s \r\n ",attmp);
                        //printf(" \r\n - tmpint = %X \r\n ",tmpint);
                        
                        if ((tmpint<0)||(tmpint>0x3FFF))
                        {
FX:
                                if (ATECHO==1) printf("\r\n\r\n%s",rx_buffer0);
                                printf("\r\n\r\nVALUE ERROR\r\n");
                                goto GT; 
                        };
                        
                        EEP=ext_eeprom_read(tmpint);
                        if (ATECHO==1) printf(" \r\n\r\n%s ",rx_buffer0);
                        printf(" \r\n+EEEPR=0x%X\r\n\r\nOK\r\n ",EEP);
                        goto GT;    
                };
                
                //-------External EEPROM write----------
                scmptmp=strncmpf(rx_buffer0,AT_EEEPW,9);
                if (scmptmp==0)
                { 
                        while (rx_buffer0[i+9]!=',')
                        {
                                attmp[i]=rx_buffer0[i+9];
                                if (!( (isdigit(attmp[i])) || (isxdigit(attmp[i])) )) goto GW;
                                i++;
                        };
                        tmpint=hexdec(attmp);
                        
                        if ((tmpint<0)||(tmpint>0x3FFF))
                        {
GW:
                                if (ATECHO==1) printf("\r\n\r\n%s",rx_buffer0);
                                printf("\r\n\r\nADDRESS ERROR\r\n");
                                goto GT; 
                        };
                        
                        for (j=0; j==16; j++) attmp[j]=0;
                        j=0;

                        while (rx_buffer0[i+10]!=0)
                        {
                                attmp[j]=rx_buffer0[i+10];
                                if (!( (isdigit(attmp[j])) || (isxdigit(attmp[j])) )) goto GD;
                                i++;
                                j++;
                        };
                        EEP=hexdec(attmp);

                        ext_eeprom_write(tmpint,EEP);
                        EEP=ext_eeprom_read(tmpint);
                        if (ATECHO==1) printf("\r\n\r\n%s",rx_buffer0);
                        printf(" \r\n\r\n ADDRESS [0x%X] \r\n VALUE [0x%X] \r\n WRITE OK\r\n\r\n  ",tmpint,EEP);
                        goto GT;
                
                };
                
                printf(" \r\n\r\n%s\r\n\r\nERROR\r\n ",rx_buffer0);

                //-------------AT COMMAND SECTOR END-----------------
GT:
                rx_counter0=0;
                rx_wr_index0=0;
                tmpint=0;
                for (i=0; i==32; i++) rx_buffer0[i]=0;
                for (i=0; i==16; i++) attmp[i]=0;
        };
        
        printf("%c",data);
   };
}

#pragma warn+

// Timer 0 overflow interrupt service routine
interrupt [17] void timer0_ovf_isr(void)
{
// Place your code here

}

// Declare your global variables here

void main(void)
{
// Declare your local variables here

// Crystal Oscillator division factor: 1
#pragma optsize-
(*(unsigned char *) 0x61)=0x80;
(*(unsigned char *) 0x61)=0x00;
#pragma optsize+

// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=P State6=P State5=P State4=P State3=P State2=P State1=P State0=P 
PORTB=0xFF;
DDRB=0x00;

// Port C initialization
// Func6=In Func5=In Func4=In Func3=In Func2=Out Func1=In Func0=In 
// State6=P State5=P State4=P State3=P State2=0 State1=P State0=P 
PORTC=0x7B;
DDRC=0x04;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=P State6=P State5=P State4=P State3=P State2=P State1=P State0=P 
PORTD=0xFF;
DDRD=0x00;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 7,200 kHz
// Mode: Normal top=FFh
// OC0A output: Disconnected
// OC0B output: Disconnected
TCCR0A=0x00;
TCCR0B=0x05;
TCNT0=0x00;
OCR0A=0x00;
OCR0B=0x00;

(*(unsigned char *) 0x80)=0x00;
(*(unsigned char *) 0x81)=0x00;
(*(unsigned char *) 0x85)=0x00;
(*(unsigned char *) 0x84)=0x00;
(*(unsigned char *) 0x87)=0x00;
(*(unsigned char *) 0x86)=0x00;
(*(unsigned char *) 0x89)=0x00;
(*(unsigned char *) 0x88)=0x00;
(*(unsigned char *) 0x8b)=0x00;
(*(unsigned char *) 0x8a)=0x00;

(*(unsigned char *) 0xb6)=0x00;
(*(unsigned char *) 0xb0)=0x00;
(*(unsigned char *) 0xb1)=0x00;
(*(unsigned char *) 0xb2)=0x00;
(*(unsigned char *) 0xb3)=0x00;
(*(unsigned char *) 0xb4)=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// Interrupt on any change on pins PCINT0-7: Off
// Interrupt on any change on pins PCINT8-14: Off
// Interrupt on any change on pins PCINT16-23: Off
(*(unsigned char *) 0x69)=0x00;
EIMSK=0x00;
(*(unsigned char *) 0x68)=0x00;

// Timer/Counter 0 Interrupt(s) initialization
(*(unsigned char *) 0x6e)=0x01;
// Timer/Counter 1 Interrupt(s) initialization
(*(unsigned char *) 0x6f)=0x00;
// Timer/Counter 2 Interrupt(s) initialization
(*(unsigned char *) 0x70)=0x00;

// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On
// USART0 Mode: Asynchronous
// USART Baud rate: 9600
(*(unsigned char *) 0xc0)=0x00;
(*(unsigned char *) 0xc1)=0x98;
(*(unsigned char *) 0xc2)=0x06;
(*(unsigned char *) 0xc5)=0x00;
(*(unsigned char *) 0xc4)=0x2F;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
(*(unsigned char *) 0x7b)=0x00;

// Global enable interrupts
#asm("sei")

i2c_init();
PORTC.2=1;

while (1)
      {
      // Place your code here
      

      };
}
