// Yak module
#define TWINT       0b10000000
#define TWEA        0b01000000
#define TWSTA       0b00100000
#define TWSTO       0b00010000
#define TWWC        0b00001000
#define TWEN        0b00000100
#define TWIE        0b00000001

#define SLA_W       0b10100000
#define SLA_R       0b10100001

#define EEPROM_BUS_ADDRESS 0xa0

//    2          AT24C01

unsigned char ext_eeprom_read(unsigned int address) 
{
        unsigned char data, addrh, addrl;
        addrh=(((address<<4)>>12)<<1);
        addrl=(char)address;
        i2c_start();
        i2c_write(EEPROM_BUS_ADDRESS | addrh);
        i2c_write(addrl);
        i2c_start();
        i2c_write(EEPROM_BUS_ADDRESS | 1 | addrh);
        data=i2c_read(1);
        i2c_stop();
        return data;
}

void ext_eeprom_write(unsigned char address, unsigned char data) 
{
        i2c_start();
        i2c_write(EEPROM_BUS_ADDRESS);
        i2c_write(address);
        i2c_write(data);
        i2c_stop();
        delay_ms(10);
}

// ================= Write byte to internal EEPROM ===========
void eeprom_write(unsigned int uiAddress, unsigned char ucData)
{
        #asm("cli")
        while(EECR.1);
        EEAR=uiAddress;
        EEDR=ucData;
        EECR.2=1;
        EECR.1=1;
        #asm("sei")
} 

// ================= Read byte from internal EEPROM =========
unsigned int eeprom_read(unsigned int uiAddress)
{       
        #asm("cli")
        while(EECR.1);
        EEAR=uiAddress;
        EECR.0=1;
        return EEDR;
        #asm("sei")
} 

